%define compilers	gcc g++ cc c++ gcc-2.96 g++-2.96 gcc-3.3.4 g++-3.3.4 gcc-3.4.3 g++-3.4.3 gcc-4.0.0 g++-4.0.0 gcc-4.0.1 g++-4.0.1

Name: ccache
Version: 2.4
Release: 10mdk
Group: Development/Other
Summary: Compiler Cache
License: GPL
URL: http://ccache.samba.org/
Source0: %{name}-%{version}.tar.bz2
BuildRoot: %{_tmppath}/%{name}-%{version}-root

%description
ccache is a compiler cache. It acts as a caching pre-processor to 
C/C++ compilers, using the -E compiler switch and a hash to detect 
when a compilation can be satisfied from cache. This often results 
in a 5 to 10 times speedup in common compilations.

To enable ccache's default use, the system admin should modify 
%{_sysconfdir}/sysconfig/ccache to "yes". If its default use is not 
enabled and you wish to use it, simply add %{_prefix}/%{_lib}/ccache/bin/ to 
the start of your \$PATH

%prep
%setup -q

%build
%configure2_5x
%make

%__cat <<EOF > %{name}.sh
#!/bin/sh

if [ -f /etc/sysconfig/ccache ]; then
    . /etc/sysconfig/ccache
fi
if [ "\$USE_CCACHE_DEFAULT" = "yes" ]; then
    if [ -z \`echo "\$PATH" | grep "%{_prefix}/%{_lib}/ccache/bin"\` ]; then
        export PATH="%{_prefix}/%{_lib}/ccache/bin:\$PATH"
    fi
fi
EOF

%__cat << EOF > %{name}.csh
#!/bin/csh

if ( -f /etc/sysconfig/ccache ) then
    eval \`sed -n 's/^\([^#]*\)=\([^#]*\)/set \1=\2;/p' < /etc/sysconfig/ccache\`
endif
if ( "\$USE_CCACHE_DEFAULT" == "yes" ) then
    if ( "\$path" !~ *%{_prefix}/%{_lib}/ccache/bin* ) then
        setenv path = ( %{_prefix}/%{_lib}/ccache/bin \$path )
    endif
endif
EOF

%install
%__rm -rf %{buildroot}
%__install -dm 755 %{buildroot}{%{_bindir},%{_prefix}/%{_lib}/ccache/bin,%{_mandir}/man1}
%__install -pm 755 ccache %{buildroot}%{_prefix}/%{_lib}/ccache/bin
%__install -pm 644 ccache.1 %{buildroot}%{_mandir}/man1
%__install -dm 755 %{buildroot}%{_sysconfdir}/profile.d
%__install -pm 755 %{name}.sh %{name}.csh %{buildroot}%{_sysconfdir}/profile.d
touch %{name}-%{version}.compilers
for name in %{compilers}; do
for comp in $name %{_target_platform}-$name; do

%__cat <<EOF > %{buildroot}%{_prefix}/%{_lib}/ccache/bin/$comp
#!/bin/sh
COMPILERDIR=/usr/bin/
if [ -f /etc/sysconfig/ccache ]; then
	. /etc/sysconfig/ccache
	if [ "\$USE_CCACHE_WITH_ICECREAM" = "yes" ]; then
    	COMPILERDIR=%{_libdir}/icecream/bin/
	fi
fi

ccache \${COMPILERDIR}${comp} "\$@"
EOF
echo "%attr(0755,root,root) %{_prefix}/%{_lib}/ccache/bin/$comp" >> %{name}-%{version}.compilers
done
done

%__mkdir_p %{buildroot}%{_sysconfdir}/sysconfig/
%__cat <<EOF > %{buildroot}/%{_sysconfdir}/sysconfig/%{name}
# Should we add the ccache compiler symlinks to PATH
# yes|no
# Please note that if added to \$PATH the user can still disable 
# it with CCACHE_DISABLE
# If not enabled by default, the user can add %{_prefix}/%{_lib}/ccache/bin/
# to their \$PATH
USE_CCACHE_DEFAULT="no"

# Enable icecream integration
USE_CCACHE_WITH_ICECREAM="no"

EOF

%__ln_s %{_prefix}/%{_lib}/ccache/bin/ccache %{buildroot}%{_bindir}/ccache


%clean
rm -rf %{buildroot}

%files -f %{name}-%{version}.compilers
%defattr(-,root,root)
%doc README
%config(noreplace) %{_sysconfdir}/profile.d/%{name}.*sh
%dir %{_prefix}/%{_lib}/ccache
%dir %{_prefix}/%{_lib}/ccache/bin
%{_bindir}/ccache
%{_prefix}/%{_lib}/ccache/bin/ccache
%{_mandir}/man1/ccache.1*
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}

%changelog
* Thu Sep 01 2005 David Walluck <walluck@mandriva.org> 2.4-10mdk
- fix icecream location on x86_64
- fix script-without-shellbang

* Mon Jun 27 2005 Helio Chissini de Castro <helio@mandriva.com> 2.4-9mdk
- Fix recursive call on ccache when USE_ICECREAM_WITH_CCACHE=no. Thanks to Olav
  Vitters <olav@bkor.dhs.org>

* Mon Jun 27 2005 Helio Chissini de Castro <helio@mandriva.com> 2.4-8mdk
- Fixed typo on profile script PATH

* Mon Jun 24 2005 Helio Chissini de Castro <helio@mandriva.com> 2.4-7mdk
- Avoid use the PATH on cluster, which leads to a /home/$USER path.
- When user not set to use icecream, compiler always point to wrong path

* Mon Mar 22 2005 Helio Chissini de Castro <helio@conectiva.com.br> 2.4-6mdk
- Fixed invalid recursive path

* Mon Feb 28 2005 Helio Chissini de Castro <helio@conetciva.com.br> 2.4-5mdk
- Add wrappers to enable integration with icecream. This wrappers remove the 
- necessity of triggers on post and postun.
- Ghost removed, since wrappers are real files now

* Wed Feb 02 2005 Nick Brown <nickbrown@mandrake.org> 2.4-4mdk
- Update compiler lists

* Sun Sep 26 2004 David Walluck <walluck@mandrake.org> 2.4-3mdk
- fix ccache.sh

* Sun Sep 26 2004 David Walluck <walluck@mandrake.org> 2.4-2mdk
- changed test in ccache.sh slightly
- macros everywhere

* Fri Sep 17 2004 Nick Brown <nickbrown@mandrake.org> 2.4-1mdk
- 2.4

* Mon Sep 13 2004 Nick Brown <nickbrown@mandrake.org> 2.3-10mdk
- instructions on package use

* Sun Sep 12 2004 Nick Brown <nickbrown@mandrake.org> 2.3-9mdk
- Update package and compiler lists

* Tue Sep 07 2004 Nick Brown <nickbrown@mandrake.org> 2.3-8mdk
- Revert last change at request of ghibo@mandrakesoft.com

* Tue Sep 07 2004 Nick Brown <nickbrown@mandrake.org> 2.3-7mdk
- Enable by default

* Sun Aug 29 2004 Nick Brown <nickbrown@mandrake.org> 2.3-6mdk
- Fix typo in ccache.csh

* Tue Aug 24 2004 Nick Brown <nickbrown@mandrake.org> 2.3-5mdk
- Check sysconfig

* Wed Aug 18 2004 Giuseppe Ghib <ghibo@mandrakesoft.com> 2.3-4mdk
- Don't let ccache.sh|csh profile scripts use ccache links before
  default un-ccached compiler.

* Tue Aug 17 2004 Giuseppe Ghib <ghibo@mandrakesoft.com> 2.3-3mdk
- Added ccache in %%{_bindir} for backward compatibility.

* Fri Aug 13 2004 Nick Brown <nickbroon@blueyonder.co.uk> 2.3-2mdk
- As the fedora package, add dynamic support for compilers

* Fri Dec 12 2003 Olivier Thauvin <thauvin@aerov.jussieu.fr> 2.3-1mdk
- 2.3
 
* Mon Feb 17 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.2-1mdk
- 2.2

* Thu Feb 06 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.1.1-1mdk
- from Jos Pablo Ezequiel Fernndez <pupeno@kde.org>:
	- Update to 2.1.1

* Tue Jan 07 2003 Lenny Cartier <lenny@mandrakesoft.com> 2.0-1mdk
- 2.0

* Fri Dec 27 2002 Olivier Thauvin <thauvin@aerov.jussieu.fr> 1.9-2mdk
- rebuild for rpm and glibc

* Wed Sep 18 2002 Olivier Thauvin <thauvin@aerov.jussieu.fr> 1.9-1mdk
- mdk adaptation

* Mon Apr 01 2002 Peter Jones <pjones@redhat.com>
- Created the package
